$(document).ready(function() {
	
	var baseURL=$('#contextPathHolder').attr('data-contextPath');

	$( "#selEstablecimiento" ).keypress(function( event ) {
		  if ( event.which == 13 ) {
			  buscar();
		  }
	});
	
	init();
	
	function init(){
		$.ajax({
			url : baseURL + "/consulta-kardex",
			async:false,
			type : "get",
			success : function(response) {
				$("#subViewDiv").html( response );
			}
		});
	}
	
	function actualizar(){
		$.ajax({
			url : baseURL + "/consulta-kardex",
			async:false,
			type : "get",
			success : function(response) {
				$('#overlay').modal('show');
				$("#subViewDiv").html( response );
				setTimeout(function() {$('#overlay').modal('hide');}, 1000);
			}
		});
	}
	
	$("#cmdActualizar").click(function (event) {
		actualizar();
    });
	
	$("#cmdBuscar").click(function (event) {
		buscar();
    });
	
	$("#cmdGuardar").click(function (event) {
		guardarAjuste();
    });
	
	function guardarAjuste(){
		var txtAjustar=$("#ajustar").val();
		var txtIdProceso=$("#hIdProceso").val();
		
		if(validaNumber(txtAjustar)){
			$.ajax({
				url : baseURL + "/registrar-ajuste",
				data : {
					idProceso:txtIdProceso,
					ajuste:txtAjustar
				},
				async:false,
				type : "get",
				success : function(response) {
					$("#subViewDiv").html( response );
				}
			});
		}else{
			alert("Número no es válido, porfavor ingrese un número válido ejemplo: -#####.## ");
		}
	}
	
	function validaNumber(ajustar){
		var re = new RegExp('^-?\\d{1,9}(\\.\\d{1,2})?$');
		var result=re.test(ajustar);
		return result;
	}
	
	function buscar(){
		var txtFechaIni=$("#txtFechaIni").val();
		var txtFechaFin=$("#txtFechaFin").val();
		var selIdEstablecimiento=$("#selEstablecimiento").val();
		
		if(selIdEstablecimiento>0){
			$.ajax({
				url : baseURL + "/create-kardex",
				data : {
					fechaIni:txtFechaIni,
					fechaFin:txtFechaFin,
					idEstablecimiento:selIdEstablecimiento
				},
				async:false,
				type : "get",
				success : function(response) {
					
				}
			});
		}else{
			alert("Seleccione el establecimiento!")
			$("#selEstablecimiento").focus();
  			$("#selEstablecimiento").select();
		}
		alert('Se inicia el proceso de creacion del kardex. Al culminar se mostrara en la lista de procesos');
	}
	
	$("#cmdDelAceptar").click(function(){
		var hIdDelete=$("#hIdDelete").val();
		var txtDenominacion = $("#txtDenominacionDelete").val().trim().toUpperCase();
        	
		$.ajax({
			url : baseURL + "/eliminar-kardex",
			data : {
				id: hIdDelete
			},
			async:false,
			type : "get",
			success : function(response) {
				$("#subViewDiv").html( response );
			}
		});
    });
	
	function isEmpty(str){
        return !str.replace(/^\s+/g, '').length; // boolean (`true` if field is empty)
    }
	
	function isInt(x) {
	   var y = parseInt(x, 10);
	   return !isNaN(y) && x == y && x.toString() == y.toString();
	}
	
});