package com.delfines.business;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.List;

import com.delfines.dao.ConnectionFactory;
import com.delfines.dao.ConnectionFactorySQL;
import com.delfines.vo.Inventario;
import com.delfines.vo.Value;

public class InventarioDatcorpBo {
	
	public void eliminarRegistros(){
		PreparedStatement ps=null;
		ResultSet rs=null;
		Integer pk=0;
        try {
        	Connection conn = ConnectionFactorySQL.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append("delete from dbo.inventario");
            //--
            ps = conn.prepareStatement(query.toString());
            ps.executeUpdate();
            
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } catch (Exception e) {
            throw new RuntimeException(e);
        }finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
	}
	
	public void insertarRegistros(Integer orden,String fecha,String codigo,String denominacion,String unidad){
		PreparedStatement ps=null;
		ResultSet rs=null;
		Integer pk=0;
        try {
        	Connection conn = ConnectionFactorySQL.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append("INSERT INTO dbo.inventario(orden,fecha,codigo,denominacion,unidad,audit_fechahora,audit_estado)VALUES(?,CONVERT(DATE, ?, 103),?,?,?,GETDATE(),'1')");
            //--
            ps = conn.prepareStatement(query.toString());
            ps.setInt(1, orden);
            ps.setString(2, fecha);
            ps.setString(3, codigo);
            ps.setString(4, denominacion);
            ps.setString(5, unidad);
            ps.executeUpdate();
            
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } catch (Exception e) {
            throw new RuntimeException(e);
        }finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
	}
	
	public void actualizaRegistros(String fecha,String denominacion,String almacen){
		PreparedStatement ps=null;
		ResultSet rs=null;
		Integer pk=0;
        try {
        	Connection conn = ConnectionFactorySQL.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append("UPDATE dbo.inventario SET linea=SUBSTRING(codigo,1,4),sublinea=SUBSTRING(codigo,5,4),fecha_inventario=?,nombre_inventario=?,almacen_inventario=?");
            //--
            ps = conn.prepareStatement(query.toString());
            ps.setString(1, fecha);
            ps.setString(2, denominacion);
            ps.setString(3, almacen);
            
            ps.executeUpdate();
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } catch (Exception e) {
            throw new RuntimeException(e);
        }finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
	}
	
	 public List<Inventario> listarInventario(){
			List<Inventario> lista = new ArrayList<Inventario>(); 
			
			PreparedStatement ps=null;
			ResultSet rs=null;
	        try {
	        	Connection conn = ConnectionFactorySQL.getInstance().getConnection();
	            
	            StringBuilder query = new StringBuilder();
	            query.append("select i.id_inventario,i.orden,i.codigo,i.denominacion,i.unidad ");
	            query.append("from dbo.inventario i ");
	            query.append("ORDER BY i.orden ASC ");
	            
	            ps = conn.prepareStatement(query.toString());
	            rs = ps.executeQuery();
	            
	            while(rs.next()){
	            	Inventario obj=new Inventario();
	            	obj.setId(rs.getInt("id_inventario"));
	            	obj.setSecuencia(rs.getInt("orden"));
	            	obj.setCodigo(rs.getString("codigo"));
	            	obj.setDenominacion(rs.getString("denominacion"));
	            	obj.setUnidad(rs.getString("unidad"));
	            	lista.add(obj);
	            }
	        } catch (SQLException e) {
	            throw new RuntimeException(e);
	        } finally {
	        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
	            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
	        }
	        
	        return lista;
	}

	 public List<Value> listarAlmacen(){
		List<Value> lista = new ArrayList<Value>(); 
		
		PreparedStatement ps=null;
		ResultSet rs=null;
        try {
        	Connection conn = ConnectionFactorySQL.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append("select codigo,denominacion from dbo.almacen order by denominacion ASC ");
            
            ps = conn.prepareStatement(query.toString());
            rs = ps.executeQuery();
            
            while(rs.next()){
            	Value obj=new Value();
            	obj.setCodigo(rs.getString("codigo"));
            	obj.setDenominacion(rs.getString("denominacion"));
            	lista.add(obj);
            }
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return lista;
	}
}