package com.delfines.dao;

import java.sql.CallableStatement;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.List;

import com.delfines.vo.ReporteKardexVo;

public final class ConnectionFactory {
	
	/**fichas**/
	public static final String URL = "jdbc:oracle:thin:mcdata/micros@10.0.0.112:1521:fbv8";
	/**cheques**/
	
	private static ConnectionFactory instance;
    private Connection connection;

    private ConnectionFactory() {
        this.connect();
    }
	
	public static ConnectionFactory getInstance() {
        if (ConnectionFactory.instance == null) {
        	ConnectionFactory.instance = new ConnectionFactory();
        }
        return ConnectionFactory.instance;
    }
	
	private void connect() {
        try {
        	System.out.println("Connect...");
        	Class.forName("oracle.jdbc.driver.OracleDriver");  
			this.connection=DriverManager.getConnection(URL);
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
	
	public Connection getConnection() {
		try {
			this.connection=DriverManager.getConnection(URL);
        } catch (SQLException e) {
            e.printStackTrace();
        }
        return this.connection;
    }
	
    /**
     * Test Connection
     */
    public static void main(String[] args) {
    	List<ReporteKardexVo> lista = new ArrayList<ReporteKardexVo>(); 
		
		PreparedStatement ps=null;
		ResultSet rs=null;
        try {
        	// Load the driver
            DriverManager.registerDriver(new oracle.jdbc.driver.OracleDriver());

            // Connect to the database
            // You can put a database name after the @ sign in the connection URL.
            //public static final String URL = "jdbc:oracle:thin:mcdata/micros@10.0.0.112:1521:fbv8";
            Connection conn =DriverManager.getConnection ("jdbc:oracle:thin:mcdata/micros@10.0.0.112:1521:fbv8");
            
    		CallableStatement callableStatement = conn.prepareCall("{call SP_INVE_VALO_3(?,?,?,?,?)}");
    		callableStatement.setInt(1, 16);
    		callableStatement.setInt(2, 0);
    		callableStatement.setString(3, "00");
    		callableStatement.setString(4, "01/01/2018");
    		callableStatement.setString(5, "01/01/2019");
    		
    		int i=callableStatement.executeUpdate();
    		if(i>0){
    			
                StringBuilder query = new StringBuilder();
                query.append("SELECT * FROM MCDATA.GTT_KARDEX_VALORIZADO_3");
                ps = conn.prepareStatement(query.toString());
                
                rs = ps.executeQuery();
        		while (rs.next()) {
        			ReporteKardexVo vo=new ReporteKardexVo(); 
        			vo.setKST_ID(rs.getInt("KST_ID"));// NUMBER(*,0),
        			vo.setKST_ADRESSE(rs.getString("KST_ADRESSE"));// VARCHAR2(254 BYTE), 
        			vo.setKST_NAME(rs.getString("KST_NAME"));// VARCHAR2(60 BYTE), 
        			vo.setFEC_INI_PER(rs.getString("FEC_INI_PER"));// DATE,
        			vo.setFEC_FIN_PER(rs.getString("FEC_FIN_PER"));// DATE,
        			vo.setART_ID(rs.getInt("ART_ID"));// NUMBER(*,0), 
        			vo.setWES_TYP(rs.getInt("WES_TYP"));// NUMBER(*,0), 
        			vo.setART_COD(rs.getInt("ART_COD"));// NUMBER(15,0), 
        			vo.setART_NAME(rs.getString("ART_NAME"));// VARCHAR2(60 BYTE), 
        			vo.setART_INFO(rs.getString("ART_INFO"));// VARCHAR2(254 BYTE), 
        			vo.setVPK_NR(rs.getInt("VPK_NR"));// NUMBER(*,0), 
        			vo.setVPK_NAME(rs.getString("VPK_NAME"));// VARCHAR2(60 BYTE), 
        			vo.setTIPO_OPE(rs.getString("TIPO_OPE"));// VARCHAR2(2 BYTE), 
        			vo.setLFS_STATUS(rs.getInt("LFS_STATUS"));// NUMBER(*,0), 
        			vo.setLFP_STATUS(rs.getInt("LFP_STATUS"));// NUMBER(*,0), 
        			vo.setWES_ID1(rs.getInt("WES_ID1"));// NUMBER(*,0), 
        			vo.setWES_ID2(rs.getInt("WES_ID2"));// NUMBER(*,0), 
        			vo.setWES_DOCDATE(rs.getString("WES_DOCDATE"));// DATE, 
        			vo.setTIPO_DOC(rs.getString("TIPO_DOC"));// VARCHAR2(2 BYTE), 
        			vo.setSERIE_DOC(rs.getString("SERIE_DOC"));// VARCHAR2(12 BYTE), 
        			vo.setNRO_DOC(rs.getString("NRO_DOC"));// VARCHAR2(60 BYTE), 
        			vo.setCNT_COM(rs.getDouble("CNT_COM"));// NUMBER(12,2), 
        			vo.setCST_UNI_COM(rs.getDouble("CST_UNI_COM"));// NUMBER(12,2), 
        			vo.setCST_TOT_COM(rs.getDouble("CST_TOT_COM"));// NUMBER(12,2), 
        			vo.setCNT_VTA(rs.getDouble("CNT_VTA"));// NUMBER(12,2), 
        			vo.setCST_UNI_VTA(rs.getDouble("CST_UNI_VTA"));// NUMBER(12,2), 
        			vo.setCST_TOT_VTA(rs.getDouble("CST_TOT_VTA"));// NUMBER(12,2), 
        			vo.setCNT_SLD_FIN(rs.getDouble("CNT_SLD_FIN"));// NUMBER(12,2), 
        			vo.setCST_UNI_SLD_FIN(rs.getDouble("CST_UNI_SLD_FIN"));// NUMBER(12,2), 
        			vo.setCST_TOT_SLD_FIN(rs.getDouble("CST_TOT_SLD_FIN"));// NUMBER(12,2),
        			
        			lista.add(vo);
        		}	
    		}
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
            if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        
    }
	
}





