package com.delfines.spring.controller;

import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.OutputStream;
import java.sql.Connection;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.servlet.ModelAndView;

import com.delfines.Constante;
import com.delfines.business.ReporteKardexBo;
import com.delfines.dao.ConnectionFactory;
import com.delfines.vo.GttKardexVo;
import com.delfines.vo.ReporteKardexVo;

import net.sf.jasperreports.engine.JasperFillManager;
import net.sf.jasperreports.engine.JasperPrint;
import net.sf.jasperreports.engine.JasperReport;
import net.sf.jasperreports.engine.export.JRPdfExporter;
import net.sf.jasperreports.engine.util.JRLoader;
import net.sf.jasperreports.export.SimpleExporterInput;
import net.sf.jasperreports.export.SimpleOutputStreamExporterOutput;

@Controller
public class KardexController {
	
	@RequestMapping(path={"/create-kardex"}, method=RequestMethod.GET)
	public void  createKardex(String fechaIni,String fechaFin,Integer idEstablecimiento,Model model,HttpServletRequest request) {
	    Thread thread = new Thread("Proceso Kardex "+System.currentTimeMillis()) {
	        public void run(){
	        	System.out.println("Inicio Proceso Kardex : "+getName());
	        	ReporteKardexBo bo=new ReporteKardexBo();
	        	Integer idKardex=bo.createKardex(idEstablecimiento,0,"00",fechaIni, fechaFin);
	        	System.out.println("Fin Proceso Kardex : "+getName()+" idKardex: "+idKardex);
	        }
	    };
	    thread.start();
	}
	
	
	@RequestMapping(path={"/eliminar-kardex"},method=RequestMethod.GET)
    public void eliminarKardex(Integer id,Model model,HttpServletRequest request) {
		 Thread thread = new Thread("Proceso delete Kardex "+System.currentTimeMillis()) {
	        public void run(){
	        	System.out.println("Inicio Proceso del Kardex : "+getName());
	        	ReporteKardexBo bo=new ReporteKardexBo();
	        	bo.eliminarKardex(id);
	        	System.out.println("Fin Proceso del Kardex : "+getName());
	        }
	    };
	    thread.start();
    }
	
	@RequestMapping(path={"/consulta-kardex"}, method=RequestMethod.GET)
	public ModelAndView  consultaKardex(Model model,HttpServletRequest request) {
	 	ReporteKardexBo bo=new ReporteKardexBo();
	 	List<GttKardexVo> lista=new ArrayList<GttKardexVo>();
       	lista=bo.reporteKardex();
	    
	    ModelAndView mv = new ModelAndView("kardex-tabla");
	    mv.addObject("lista",lista);
        return mv;
	}
	
	@RequestMapping(path={"/registrar-ajuste"}, method=RequestMethod.GET)
	public ModelAndView registrarAjuste(Integer idProceso,Double ajuste,Model model,HttpServletRequest request) {
	 	ReporteKardexBo bo=new ReporteKardexBo();
       	bo.registrarAjuste(idProceso,ajuste);
       	
       	List<GttKardexVo> lista=new ArrayList<GttKardexVo>();
       	lista=bo.reporteKardex();
	    
	    ModelAndView mv = new ModelAndView("kardex-tabla");
	    mv.addObject("lista",lista);
        return mv;
	}
	 
	@RequestMapping(path={"/parameter-kardex"}, method=RequestMethod.GET)
	public void  parameterKardex(Integer idKardex,Integer idKst,Model model,HttpServletRequest request) {
		request.getSession().setAttribute("p_idKardex",idKardex);		
		request.getSession().setAttribute("p_idKst",idKst);
	}
	
	@RequestMapping(path={"/impresion-kardex"}, method=RequestMethod.GET)
	public void  impresionKardex(HttpServletRequest request, HttpServletResponse response) {
	    try {
	    	
	    	Integer idKardex=(Integer)request.getSession().getAttribute("p_idKardex");
	    	Integer idKst=(Integer)request.getSession().getAttribute("p_idKst");
	    	
	    	
	    	if(idKardex!=null&&idKardex>0){
	    		String jasperDir = "/jasper/";
	            String realPathtoJasper =  request.getServletContext().getRealPath(jasperDir);
	            System.out.println(realPathtoJasper);
	            
	        	JasperReport reporte = (JasperReport) JRLoader.loadObject(new File(realPathtoJasper+"/reporte_kardex_detalle.jasper"));
	        	if(idKst.equals(3)){
	        		reporte = (JasperReport) JRLoader.loadObject(new File(realPathtoJasper+"/reporte_kardex_detalle_principal.jasper"));
	        	}
	        	
	            Map<String, Object> parametros = new HashMap<String, Object>();
	            parametros.put("P_IMAGE_PATH",realPathtoJasper+"/logo.jpg");
	            parametros.put("SUBREPORT_DIR",realPathtoJasper+"\\");
	            parametros.put("P_ID_GTT_KARDEX",idKardex);
	            
	            Connection conn = ConnectionFactory.getInstance().getConnection();
	            
	            JasperPrint jasperPrint = JasperFillManager.fillReport(reporte, parametros,conn);
	            
	            JRPdfExporter pdfExporter = new JRPdfExporter();
	            pdfExporter.setExporterInput(new SimpleExporterInput(jasperPrint));
	            ByteArrayOutputStream pdfReportStream = new ByteArrayOutputStream();
	            pdfExporter.setExporterOutput(new SimpleOutputStreamExporterOutput(pdfReportStream));
	            pdfExporter.exportReport();
	            
	            response.setContentType("application/pdf");
	            response.setHeader("Content-Length", String.valueOf(pdfReportStream.size()));
	            response.addHeader("Content-Disposition", "inline; filename=kardex.pdf;");
	            
	            OutputStream responseOutputStream = response.getOutputStream();
	            responseOutputStream.write(pdfReportStream.toByteArray());
	            responseOutputStream.close();
	            pdfReportStream.close();
	    	}
        } catch (Exception e) {
            e.printStackTrace();
        }
		
	}
	
}
